<template>
  <div class="v-notification">
    <transition-group
      name="v-transition-animate"
    >
      <div
        class="v-notification__content"
        v-for="message in messages"
        :key="message.id"
        :class="message.icon"
      >
        <div class="content__text">
          <span>{{ message.name }}</span>
        </div>
      </div>
    </transition-group>
  </div>
</template>

<script>
import {ref, onMounted, watch} from 'vue'
export default {
  name: 'v-notification',
  props: {
    messages: {
      type: Array,
      default: () => {
        return []
      }
    },
    timeout: {
      type: Number,
      default: 3000,
      required: true
    }
  },
  setup(prop) {
    function hideNotification() {
      if (prop.messages.length) {
        setTimeout(function () {
          prop.messages.splice(prop.messages.length - 1, 1)
        }, prop.timeout)
      }
    }
    watch(prop.messages, () => {
      hideNotification()
    })
    onMounted(() => {
      hideNotification()
    })
    return {
    }
  }
}
</script>

<style scoped lang="css">
.v-notification{
  position: fixed;
  top: 80px;
  right: 16px;
  z-index: 11;
  display: flex;
  flex-direction: column-reverse;
}
.messages_list {
  display: flex;
  flex-direction: column;
}
.v-notification__content {
  padding: 16px;
  border-radius: 4px;
  color: white;
  display: flex;
  justify-content: space-between;
  align-items: center;
  height: 50px;
  margin-bottom: 16px;
}
.v-notification__content.error{
  background: red;
}
.v-notification__content.warning {
  background: orange;
}
.v-notification__content.check_circle {
  background: green;
}
.v-transition-animate-enter {
  transform: translateX(120px);
  opacity: 0;
}
.v-transition-animate-enter-active {
  transition: all .6s ease;
}
.v-transition-animate-enter-to {
  opacity: 1;
}
.v-transition-animate-leave {
  height: 50px;
  opacity: 1;
}
.v-transition-animate-leave-active {
  transition: transform .6s ease, opacity .6s, height .6s .2s;
}
.v-transition-animate-leave-to {
  height: 0;
  transform: translateX(120px);
  opacity: 0;
}
.v-transition-animate-move {
  transition: transform .6s;
}
</style>
